#ifndef GSTypes_H
#define GSTypes_H
//------------------------------------------------------------------------------
/* File: GSTypes.h
  
   Desc: This file implements some basic types if not used with any Windowing Syste,
  
   Copyright (c) 2001-2002 Gireesh Sadasivan.  All rights reserved.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.*/
//------------------------------------------------------------------------------

// Commonly Used Classes

class CGS8x8Block;
class CGSMacroBlock;
class CGSPicture;
class CGSIPicture;
class CGSPPicture;
class CGSBPicture;
class CGSVLCoder;
class CGSBitWriter;
class CGSSequence;
class CGSMotionCalculator;
class CGSEncoderController;

enum PictureType
{
    None = 0,
    I = 1,
    P = 2,
    B = 3,
    D = 4
};


enum MacroBlockType
{
    SkipBlock    = 0,
    IntraBlock   = 1,
    PatternBlock = 2,
    BwdBlock     = 4,
    FwdBlock     = 8,
    QuantBlock   = 16
};


enum MotionVecType
{
    FieldVector     = 1,
    Frame16x8Vector = 2,
    DualPrimeVector = 3
};


enum MotionVectorFormat
{
    FieldFormat = 0,
    FrameFormat = 1
};



#ifndef GSPRIMITIVEDATATYPES
#define GSPRIMITIVEDATATYPES
#define uint16  unsigned short
#define sint16  signed   short
#define sint32           int
#define uint32  unsigned int
#define ulong32 unsigned long
#define slong32 signed   long
#define ubyte8  unsigned char
#define sbyte8           char
// 32 Byte Alingned Types
#define sint16A32  __declspec(align(32)) signed   short
#define ubyte8A32  __declspec(align(32)) unsigned char
#define sint16A16  __declspec(align(16)) signed   short
#define ubyte8A16  __declspec(align(16)) unsigned char

#endif  //GSPRIMITIVEDATATYPES

template <class T>  T *Align32( T *pVoid )
{
    if( (int)pVoid & 0x1F )
    {
        pVoid = (T *)(((int)pVoid + 31) & 0xffffffe0);	// Force 32 byte alignment
    }
    return pVoid;
}




#endif //#ifndef GSTypes_H
