#ifndef VLCoder_H
#define VLCoder_H
//------------------------------------------------------------------------------
/* File: VLCoder.h
  
   Desc: This is the header file for the VLCoder. It assists in writing the
         VLCoder header informamtion and holds a BitWriter Object that the
         Controller can use.
  
   Copyright (c) 2001-2002 Gireesh Sadasivan.  All rights reserved.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.*/
//------------------------------------------------------------------------------

#include <GSTypes.h>


struct VLC
{
    ubyte8 ucCode;
    ubyte8 ucSize;
};

struct VLCx
{
    uint16 usCode;
    ubyte8 ucSize;
};


class CGSVLCoder
{
    friend class CGS8x8Block;
    private:
        CGSBitWriter &BitWriter;
        bool         IsIntraVLCFormat;
    public:
        CGSVLCoder( CGSBitWriter &aBitWriter );
        void PutLuminDC( sint16 Val );
        void PutChrominDC( sint16 Val );
        void PutACFirst( sint16 iRun, sint16 iVal );
        void PutAC( sint16 iRun, sint16 iVal );
        void PutEndOfBlock();
        void PutMacroBlockType( PictureType ePictType, MacroBlockType eBlockType );
        void PutMacroBlockAddrInc( ubyte8 ucIncrement );
        void PutMotionVector( int iVector );
        void PutDualMotionVector( int iDMV );
        void PutCodedBlockPattern( int iCBP );

        void SetIntraVLCFormat()   { IsIntraVLCFormat = true; }
        void ClearIntraVLCFormat() { IsIntraVLCFormat = false; }
};



#endif //#ifndef VLCoder_H
