#include <GSEncCtl.h>
#include <memory.h>

void MotionTest( CGSEncoderController &MyController )
{
    size_t imageWidth = 320 , imageHeight = 240;
    size_t imageSize = 2 * imageHeight * imageWidth;
    ubyte8 *pSampleImage = new ubyte8[imageWidth*imageHeight*2];
    if( pSampleImage )
    {
        MyController.Initialize( imageWidth, imageHeight, "D:\\MyRecordings\\MPEG2TST.MPG" );
        memset( pSampleImage, 127, imageSize );
        sint16 TopLeftY = 0, TopLeftX = 0;
        for( int j = 0; j < 320; j++ )
        {
            ubyte8 *pTopLeft = pSampleImage + 640*TopLeftY + 2*TopLeftX;
            for( int i = 0; i < 16; i++ )
            {
                ubyte8 *pBuffer = pTopLeft;
                for( int k = 0; k < 16; k++ )
                {
                    *pBuffer++ = 255;
                }   pBuffer++; // Skip Chrominance
                pTopLeft += 640;
            }

            TopLeftX++;
            if( (j+1)%4 )TopLeftY++; // 4:3 Aspect Ratio, make the block move diagonally

            if( TopLeftX > 320 )TopLeftX = 320;
            if( TopLeftY > 224 )TopLeftY = 224;


            MyController.ProcessImage( pSampleImage );
        }
        MyController.Finalize();
    }
}


