#include <GSTypes.h>


        static __forceinline int MotionErrorXMM( ubyte8* frame, ubyte8* block, int fx, int fy, int iWidth )
        {
            static __int32 DivBy8 = 0x00000007;
            static __int32 Plus64 = 64;

            __int32 iWidthx2 = 2*iWidth;
            __int32 iWidthx3 = 3*iWidth;
            __int32 iWidthx4 = 4*iWidth;
            __int32 end_block;

            int iVal;

            _asm
            {
                   pxor   mm6, mm6                           ;mm6 mm7 two buffers for final sum
                   pxor   mm7, mm7                           ; of abs. differences
                   mov    end_block, 256                     ;initialising of pointer to end of macro block
                   mov    eax, fy                            ;y coordinate of reference macro block in reference frame 
                   mov    ebx, iWidth                        ; to multiply below   
                   imul   eax, ebx                           ;distance of macro block from frame begining in pixels.
                   mov    edx, frame                         ;pointer to  reference frame into edx.
                   lea    edx, [edx + eax]                   ;adress  of the beginning of fy line of compensated frame
                   add    edx, fx                            ;pointer to reference macro block into    edx
                   mov    ebx, block                         ;pointer to  estimated block into         ebx
                   add    end_block, ebx                     ;pointer the end of estimated block


                   ;SIMPLE_READ
                   ;reading  unaligned data with 2 simple MOVQ's every line  
                   ;aligned data strictly from memory
                   ;PSADBW - suming the absolute diferences of 8 pairs of pixels
                   ;unrolling of loop for 4 raws
                   ;edx - pointer to reference block line beginning(unaligned)
                   ;ebx - pointer to estimated block line beginning (aligned)
                   ;iWidth - the distance in bytes from pixel to pixel just below it
  
                simple_read:      
                   movq    mm1,[edx] 
                   movq    mm2,8[edx]
                   psadbw  mm1, [ebx]                   
                   psadbw  mm2,8[ebx]                 
                   paddw   mm6, mm1
                   paddw   mm7, mm2
                    
                    
                                  
                   movq    mm1,[edx]+ iWidth 
                   movq    mm2,8[edx]+ iWidth
                   psadbw  mm1,[ebx+16]               
                   psadbw  mm2,[ebx+24]               
                   paddw   mm6, mm1
                   paddw   mm7, mm2
                                       

                   movq    mm1,[edx] + iWidthx2
                   movq    mm2,8[edx]+ iWidthx2
                   psadbw  mm1,[ebx+32]               
                   psadbw  mm2,[ebx +40]                
                   paddw   mm6, mm1
                   paddw   mm7, mm2


                     
                   movq    mm1, [edx]  + iWidthx3
                   movq    mm2, 8[edx] + iWidthx3
                   psadbw  mm1, [ebx+48]                 
                   psadbw  mm2, [ebx +56]                
                   paddw   mm6, mm1
                   paddw   mm7, mm2
                    
                     
                   add     ebx, 64
                   add     edx, iWidthx4
                   cmp     ebx, end_block      ;if end of block stop
                   jne     simple_read
                   jmp     end_prog


                end_prog:    
                    paddd mm7,mm6
                    movd  iVal, mm7
            }
            return iVal;
        }
