#ifndef GSEncCtl_H
#define GSEncCtl_H
//------------------------------------------------------------------------------
/* File: GSEncCtl.h
  
   Desc: GSEncoderController Header File
  
   Copyright (c) 2001-2002 Gireesh Sadasivan.  All rights reserved.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.*/
//------------------------------------------------------------------------------

#include <stdio.h>
#include <GSTypes.h>

class CGSEncoderController
{
    protected:
        sint16              imageWidth;
        sint16              imageHeight;
        slong32             imagePlaneSize;
        ubyte8              numberOfPicturesInGOP;
        ulong32             uPictureCount;
        bool                isInitialized;
        CGSPicture          *pCurrentPicture;
        CGSPicture          *PictureArray[15];
        FILE                *pMPEG2File;
        FILE                *pDebugFile;
        CGSSequence         *pSequence;
        CGSBitWriter        *pBitWriter;
        CGSVLCoder          *pVLCoder;
        CGSMotionCalculator *pMotionCalculator;
static  PictureType         PictureTypeArray[15];

    public:
        
        CGSEncoderController()
        {
            isInitialized     = false;
            pMPEG2File        = 0;
            pSequence         = 0;
            pBitWriter        = 0;
            pVLCoder          = 0;
            uPictureCount     = 0;
            pMotionCalculator = 0;
        }

        ~CGSEncoderController()
        {
            if( isInitialized )Finalize();
        }

        int  Initialize( sint16 biWidth, sint16 biHeight, const sbyte8 *pFileName  );
        void ProcessImage( ubyte8 *pOrignalImage );
        void Finalize();
        void CaptureSomeFrames( ubyte8 *pImage );
        int  CreatePictures();
        void FinalizePictures();
};

#endif //#define GSEncCtl_H

